]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- rm: option `--interactive' doesn't allow an argument
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
36eccf0d
ER
15%__rm /bin/rm --interactive=never
16
33040789 17# Build system path macros.
18#
bddadece
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
f93109a0 21%__autopoint autopoint --force
22
83094b62 23%__gettextize { \
8a995cff 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 25 gettextize --copy --force --no-changelog; \
97589b6e 26 else \
3241033b 27 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
3241033b 30 cp -f po/Makevars{.template,}; \
8a995cff 31 fi; \
8a995cff 32}
f93109a0 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
fb59e475 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
c26f1b59 39%__libtoolize libtoolize --copy --force --install
33040789 40
384e1b2b 41# Path to top of build area.
f5f7156a 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 43
81e450f7
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
6a5eda77 47%dependencytracking %{nil}
3241033b 48
e5da9169
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
7bf0526c 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
c9d403e1 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
19f42054 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
810fa5c4 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 73# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
7b6f1112 79 for (i = 1; i in I; i++) { A=0; \
810fa5c4 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
09a90176 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 95 %{filter_out}
96}')
97
98e7f050
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
810fa5c4 104%rpmldflags %(awk 'BEGIN {
c05a0741 105 split("%{?optldflags}",I);
810fa5c4 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
25f52d1a 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
9c404149 124#-----------------------------------------------------------------
9f4ce098 125%configure2_13 { \
9c404149
AM
126 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
127 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
128 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 129 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 130 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 131 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 132 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
133 %{?__cc:CC="%{__cc}" ; export CC ; } \
134 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 135 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 136 --host=%{_target_platform} \
9c404149
AM
137 --prefix=%{_prefix} \
138 --exec-prefix=%{_exec_prefix} \
139 --bindir=%{_bindir} \
140 --sbindir=%{_sbindir} \
141 --sysconfdir=%{_sysconfdir} \
142 --datadir=%{_datadir} \
143 --includedir=%{_includedir} \
144 --libdir=%{_libdir} \
145 --libexecdir=%{_libexecdir} \
146 --localstatedir=%{_localstatedir} \
147 --sharedstatedir=%{_sharedstatedir} \
148 --mandir=%{_mandir} \
149 --infodir=%{_infodir} \
b6c5da52 150 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 151 %{dependencytracking} \
9c404149
AM
152}
153
89f4ca1f 154%__cmake /usr/bin/cmake
39b9534b
ER
155%cmake { \
156CC="%{__cc}" \
157CXX="%{__cxx}" \
158CFLAGS="%{rpmcflags}" \
159CXXFLAGS="%{rpmcxxflags}" \
12513dc1 160LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
161%{__cmake} \
162}
163
164# override __scons to add -j4 in your ~/.rpmmacros for parallel make
165%__scons /usr/bin/scons
166%scons { \
167%{__scons} \
5c76736d
ER
168 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
169 CFLAGS="${CFLAGS:-%rpmcflags}" \
170 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
171 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 172 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
173 %{?__cc:CC="%{__cc}"} \
174 %{?__cxx:CXX="%{__cxx}"} \
175 libsuffix=%{_lib} \
176 prefix=%{_prefix} \
39b9534b
ER
177}
178
6339d32d 179# waf. see waf.spec
89f4ca1f 180# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
181%__waf /usr/bin/waf
182%waf { \
6339d32d
ER
183CC="%{__cc}" \
184CXX="%{__cxx}" \
9e244007 185CPP="%{__cpp}" \
6339d32d
ER
186CFLAGS="%{rpmcflags}" \
187CXXFLAGS="%{rpmcxxflags}" \
188%{__waf} \
6339d32d
ER
189}
190
4a6b0d54 191#----------------------------------------------------------------
9bacbb5b 192#%configure_cache 0
fe6c4bdd 193%configure_cache_file %{buildroot}.configure.cache
73f832b3 194
57f4166d 195%configure {./configure \
4a6b0d54
AF
196 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
197 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 198 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 199 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 200 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 201 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
202 %{?__cc:CC="%{__cc}"} \
203 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 204 --host=%{_target_platform} \
4a6b0d54
AF
205 --build=%{_target_platform} \
206 --prefix=%{_prefix} \
207 --exec-prefix=%{_exec_prefix} \
208 --bindir=%{_bindir} \
209 --sbindir=%{_sbindir} \
210 --sysconfdir=%{_sysconfdir} \
211 --datadir=%{_datadir} \
212 --includedir=%{_includedir} \
213 --libdir=%{_libdir} \
214 --libexecdir=%{_libexecdir} \
215 --localstatedir=%{_localstatedir} \
216 --sharedstatedir=%{_sharedstatedir} \
217 --mandir=%{_mandir} \
218 --infodir=%{_infodir} \
b6c5da52 219 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 220 %{dependencytracking} \
9bacbb5b 221 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
222}
223
b3b1397b
ER
224# overload to insert debuginfo package
225%prep \
226%if 0%{?_enable_debug_packages}\
227%{debug_package}\
228%endif\
229%%prep\
230%{nil}
231
9c404149 232# Location of autoconf macros
7f0f4a79 233%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 234
e2804f99 235# Location of omf files
7f0f4a79 236%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 237
e987a186 238# Location of pkgconfig files
9a4e877a 239%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
240# noarch pkgconfig files
241%_npkgconfigdir /usr/share/pkgconfig
e987a186 242
486b0b5f 243# Location of desktop files
244%_desktopdir /usr/share/applications
86dff2d0 245%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 246
481463e9 247# Location of pixmaps for applnk/desktop files
e1f0a822 248%_pixmapsdir /usr/share/pixmaps
9c404149 249
481463e9 250# Location of themable icons for applnk/desktop files
b36c8e2a 251%_iconsdir /usr/share/icons
252
e987a186
JB
253# Location of fonts directories
254%_fontsdir /usr/share/fonts
255
b3282f3f 256# Location of Gtk and associated libraries documentation
fe6c4bdd 257%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 258
fc4d7771 259# Location of KDE documentation
fe6c4bdd 260%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 261
5869828c 262# unsermake script
263%__unsermake /usr/share/unsermake/unsermake
264
9c404149
AM
265# Current date
266%date %(LC_ALL="C" date +"%a %b %d %Y")
267
9c404149
AM
268# Example files, programs, scripts...
269%_examplesdir /usr/src/examples
270
c8f7e820 271# Alternative kernel type/version
261729d9 272%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 273
8377d27d 274# The directory holding Linux kernel sources
261729d9 275%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 276
9c404149 277# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 278%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 279
8f74418b 280# Requires name = version-release
d514eecd 281%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
8bf3719d 282
f5f7156a
ER
283%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
284%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
285%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
286%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
287%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
288%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 289
d514eecd
ER
290# XXX: why epoch 0 is stripped?
291%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
292%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
01a9f990 293
c94807f3 294%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 295
296# kernel version-release handling
95125403
ER
297%__kernel_ver %{expand:%%global __kernel_ver %( \\
298 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
299 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
300 echo ${Z:-ERROR}; \\
1a7d3518 301)}%__kernel_ver
95125403 302
c94807f3
ER
303%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
304%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
305%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
306%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 307
6262f001
ER
308# `uname -r` to be used in @release field
309%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
310
e00dd7f6 311# sgml macros
3241033b
ER
312%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
313%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
314%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
315%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
316%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
317%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 318%docbook_sgmlcat_fix() { for l in \
319'' \
320' -- default decl --' \
321'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
322' -- hacks for opensp --' \
323'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
325'' \
326; do echo $l; done >> %1 \
327}
328
eea64748
ER
329# vim - "
330
4f044018
ER
331# minimum file size needed for compressed documents.
332# just smaller files than this get larger when compressed.
a88ae20f
ER
333# some stats:
334# - 0 byte file compressed was 25 bytes .gz
335# - 39 byte file was compressed as 57
336# - with test/test.spec@man 158 byte file was compressed also 158
337%_min_compress_bytes 159
4f044018 338
9c404149
AM
339#-----------------------------------------------------------------
340# find and gzip all files in %{_mandir} and %{infodir}
341#
342# Requires: xargs, find
343#
344#%no_install_post_compress_docs 1
345%__spec_install_post_compress_docs { \
53d5af13 346%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 347 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 348 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 349 echo "Compress man pages: $i"; \
4f044018
ER
350 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
351 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
352 find $RPM_BUILD_ROOT$i -type l | while read a; do \
353 m=$(readlink $a); \
354 rm -f $a; \
355 echo .so ${m##*/} > $a; \
356 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
357 done; \
4f044018 358 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
359 fi; \
360 done; \
728ad671
JB
361 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
362 echo "Compress info pages: %{_infodir}"; \
363 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
364 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
365 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 366 fi; \
53d5af13 367}; __spec_install_post_compress_docs } }
9c404149
AM
368
369#-----------------------------------------------------------------
370# Strip executable binaries and shared object files
371#
372# Requires: find, awk, strip, cut, xargs
373#
a2ad2754
JB
374# Special macros which affect this process:
375#%no_install_post_strip 1 # disable stripping at all
376#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
377#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
378#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
379#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
380#
9c404149 381%__spec_install_post_strip {%{!?debug: \
53d5af13 382%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 383if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
384 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
385 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
386 if [ "$modulelist" ]; then \
387 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 388 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
389 echo "$modulelist" | xargs -l512 chmod u+w; \
390 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
391 echo "DONE"; \
392 fi; \
eea64748 393 fi; \
0ac49134 394 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
395 if [ -n "$filelist" ]; then \
396 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
397 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
398 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 399 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 400 if [ -n "$elfexelist" ]; then \
4d5370ac 401 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
402 chmod u+w $elfexelist; \
403 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
404 echo "DONE"; \
405 fi; \
406 if [ -n "$elfsharedlist" ]; then \
4d5370ac 407 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
408 chmod u+w $elfsharedlist; \
409 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
410 echo "DONE"; \
411 fi; \
412 if [ -n "$archiveslist" ]; then \
4d5370ac 413 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
414 chmod u+w $archiveslist; \
415 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
416 echo "DONE"; \
417 fi; \
98a06bad 418 fi; \
0ac49134
ER
419 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
420 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
421 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 422 if [ -n "$filelist_all" ]; then \
4d5370ac 423 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 424 chmod u+w $filelist_all; \
f89ccb5f 425 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 426 echo "DONE"; \
9c404149 427 fi; \
f89ccb5f 428 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 429 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 430 chmod u+w $filelist_unneeded; \
f89ccb5f 431 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 432 echo "DONE"; \
8f74418b 433 fi; \
f89ccb5f 434 if [ -n "$filelist_debug" ]; then \
4d5370ac 435 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 436 chmod u+w $filelist_debug; \
f89ccb5f 437 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 438 echo "DONE"; \
9f0d4f36 439 fi; \
53d5af13 440fi; }; __spec_install_post_strip } } }
3241033b 441
fc5d7e20 442#-----------------------------------------------------------------
443# remove all RPATH from executable binaries and shared object files
444#
445# Requires: find, awk, cut, xargs, chrpath, uname
446#
a2ad2754
JB
447# Special macros which affect this process
448#%no_install_post_chrpath 1 # disable chrpath at all
449#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
450#
fc5d7e20 451%__spec_install_post_chrpath {%{!?debug: \
53d5af13 452%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 453if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 454 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 455 if [ -n "$files" ]; then \
d5517264 456 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 457 fi; \
98a06bad 458 if [ -n "$objs" ]; then \
4d5370ac 459 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
460 echo "$objs" | \
461 while read file; do \
462 rpath= ; \
463 chmod u+w "$file"; \
5541bf26 464 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
465 case $dir in \
466 '$ORIGIN' ) \
467 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
468 else rpath="$rpath:$dir" ; fi ; \
469 continue ; \
470 ;; \
471 esac ; \
f9abaddb
AM
472 newdir=$(readlink -m "$dir"); \
473 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
474 case $dir in \
475 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
476 echo "remove-rpath: $dir in $file"; \
477 ;; \
478 * ) \
479 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
480 else rpath="$rpath:$dir" ; fi ; \
481 ;; \
482 esac ; \
483 done ; \
484 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
485 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
486 done; \
487 fi; \
53d5af13 488fi; }; __spec_install_post_chrpath } } }
3241033b 489
d72c185f 490#-----------------------------------------------------------------
ccb8ae8d 491# Find and gzip all kernel modules
492#
493# Requires: find
494#
fe6c4bdd 495#%no_install_post_compress_modules 1
ccb8ae8d 496%__spec_install_post_compress_modules { \
53d5af13 497%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 498 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 499 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
500 if [ "$q" ]; then \
501 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
502 echo "$q" | xargs -r %{__gzip} -9nf; \
503 echo "DONE"; \
504 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
505 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
506 fi; \
3241033b 507 fi; \
53d5af13 508}; __spec_install_post_compress_modules } }
9c404149 509
ef64802f
ER
510# Remove common Perl files we don't package
511%__spec_install_post_perl_clean {\
512%{!?no_install_post_perl_clean: \
513%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
514} }
515
83094b62 516#-----------------------------------------------------------------
0e4cb4dd 517# Update GConf2 schemas
83094b62 518#
519# Requires: GConf2
520#
46885239 521%gconf_schema_install() \
307ac6c9
ER
522 umask 022; \
523 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
524 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 525%{nil}
46885239 526
527%gconf_schema_uninstall() \
24336a54 528if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 529 umask 022; \
24336a54
ER
530 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
531 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 532fi; \
f93109a0 533%{nil}
534
535#-----------------------------------------------------------------
536# Update desktop MIME database
c0a4caa0 537# requires: desktop-file-utils
c3bcd10e 538%update_desktop_database() {{ \
f93109a0 539 umask 022; \
fb59e475 540 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
541};} \
542%{nil}
f93109a0 543
c3bcd10e
ER
544%update_desktop_database_post %update_desktop_database
545
546%update_desktop_database_postun() {{ \
f27cf2fd 547if [ "$1" = "0" ]; then \
c00bf95c 548 %update_desktop_database \
f27cf2fd 549fi; \
c00bf95c
MB
550};} \
551%{nil}
f93109a0 552
fb59e475 553#-----------------------------------------------------------------
554# Update shared MIME info database
555# requires: shared-mime-info
556#
c3bcd10e 557%update_mime_database() {{ \
fb59e475 558 umask 022; \
559 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
560};} \
561%{nil}
fb59e475 562
563#-----------------------------------------------------------------
564# Update icon cache
565# requires: gtk+
566#
c3bcd10e 567%update_icon_cache() {{ \
fb59e475 568 umask 022; \
072f4b80 569 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
570};} \
571%{nil}
fb59e475 572
f93109a0 573#-----------------------------------------------------------------
574# Update scrollkeeper database
575# requires: scrollkeeper
576#
577%scrollkeeper_update_post() \
f93109a0 578 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 579%{nil}
f93109a0 580
581%scrollkeeper_update_postun() \
f27cf2fd 582if [ "$1" = "0" ]; then \
f93109a0 583 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 584fi; \
f93109a0 585%{nil}
586
9c404149
AM
587#-----------------------------------------------------------------
588# post %install sequence:
589# - autodeps exceptions
590# - compress all man and info pages,
591# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 592# - compress kernel modules if any
9c404149
AM
593
594###################################################################
595# Requires/Provides automation
3e202b06 596# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 597#
2892b5df
JB
598%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
599%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
600%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
601%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
602%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 603
338726a6
JB
604#%_noautocompressdoc %{nil}
605#
8f74418b
MM
606%_missing_doc_files_terminate_build 1%{nil}
607%_unpackaged_files_terminate_build %{nil}
8781dc74 608# (X)emacs support
d77dcb61 609%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
610%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
611%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 612
02b58f60
JK
613%__php_provides %{nil}
614%__php_requires %{nil}
615%__perl_provides %{nil}
616%__perl_requires %{nil}
fa3497cd 617%__mono_provides %{nil}
618%__mono_requires %{nil}
25043cd4
AF
619
620# Perl specific macro definitions.
c94807f3
ER
621%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
622%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
623%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
624%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
625%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
626%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 627
45c00b39 628# Ruby
c94807f3
ER
629%__ruby /usr/bin/ruby
630%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
631%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
632%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
633%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
634%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
635%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
636%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 637%ruby_rdocdir /usr/share/rdoc
c94807f3 638%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
639%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
640%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 641
7ccf7643 642%php_pear_dir /usr/share/pear
7813c433 643%php_data_dir /usr/share/php
c94807f3
ER
644%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
645%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
646%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 647
0c5d1b9b 648# extract php/zend api versions
c94807f3
ER
649%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
650%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
651%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
652%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
653%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
654%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
655%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
656
657# helper macro
f952c0f3 658%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
659
660# macros for public use
661# for php extensions (php-pecl)
68b68193 662%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 663%{__php_api_requires zend_module_api} \
f952c0f3
ER
664%{__php_api_requires -v %php_major_version debug php_debug} \
665%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 666
c1b2705c
ER
667# for zend extensions
668%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 669%{__php_api_requires zend_extension_api} \
f952c0f3
ER
670%{__php_api_requires -v %php_major_version debug php_debug} \
671%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 672
934c685f
ER
673# for php pdo modules (php-pecl-PDO_*)
674%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
675
6c3b8203
ER
676# for using PHP post scripts. for PHP >= 5.0
677%php_webserver_restart \
678[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 679[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
680if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
681 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
682 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
683 %service -q php-fcgi restart \
684 fi \
685fi \
6c3b8203
ER
686%{nil}
687
688# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
689%php4_webserver_restart \
690[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 691[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
692if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
693 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
694 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
695 %service -q php-fcgi restart \
696 fi \
697fi \
6c3b8203
ER
698%{nil}
699
578e9248 700# X.org helper macros
434ab5a2
ER
701%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
702%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
703
c94807f3
ER
704%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
705%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
706%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
707%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
708%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 709
434ab5a2 710%requires_xorg_xserver_extension \
97486460
AM
711%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
712%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
713%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
714%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
715%{nil}
716
717%requires_xorg_xserver_xinput \
97486460
AM
718%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
719%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
720%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
721%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
722%{nil}
723
724%requires_xorg_xserver_font \
97486460
AM
725%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
726%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
727%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
728%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
729%{nil}
730
731%requires_xorg_xserver_videodrv \
97486460
AM
732%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
733%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
734%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
735%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 736%{nil}
578e9248 737
25043cd4
AF
738# Python specific macro definitions.
739# python main version
2383a9da 740%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
741
742# directories
2383a9da 743%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 744%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 745%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 746%py_incdir /usr/include/python%{py_ver}
7ccf7643 747%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 748%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 749%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
750
751# pure python modules compilation
3241033b 752%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 753
3241033b 754%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
755
756# Software written in Python language require Python with main version
e63cd81d 757%pyrequires_eq() Requires: %1
25043cd4 758
f12c2314
AF
759# Hardlink binary identical .pyc and .pyo files
760# (idea by glen <at> pld-linux <dot> org)
761%__spec_install_post_py_hardlink {\
53d5af13 762%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f12c2314 763[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
83f0d22e 764 b="${a%.pyc}.pyo"; \
f12c2314
AF
765 if cmp -s "$a" "$b"; then \
766 ln -f "$a" "$b"; \
767 fi; \
768done \
53d5af13 769}; __spec_install_post_py_hardlink } }
f12c2314 770
9227b3f9 771# remove python sources, so that check-files won't complain
f12c2314
AF
772# (idea by glen <at> pld-linux <dot> org)
773%py_postclean() \
0f82e280 774for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 775 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
776done \
777%{nil}
778
0fc5cff8 779# depmod macro
780%depmod() { \
f6148427 781umask 022; \
0fc5cff8 782if [ -e /boot/System.map-%1 ]; then \
3241033b 783 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 784else \
3241033b
ER
785 if [ -e /boot/System.map ]; then \
786 /sbin/depmod -a -F /boot/System.map %1; \
787 else \
788 /sbin/depmod -a %1; \
789 fi \
0fc5cff8 790fi; \
791}
792
2afc6e64 793# XMMS specific macros
c94807f3
ER
794%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
795%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
796%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
797%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
798%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
799%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
800%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
801%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
802%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
803%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
804
805%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 806
848c0d68 807# user/group checking macros
808#
809# Usage:
810# %userremove myuser
811#
812%userremove /usr/lib/rpm/user_group.sh user del
813%groupremove /usr/lib/rpm/user_group.sh group del
814#
815# Usage:
816# if %usertestrm myuser; then
817# /usr/sbin/userdel -r myuser
818# Note:
819# use these macros only if you need to call userdel/groupdel with
820# a non-standard option or take an extra action; otherwise use the
821# %userremove/%groupremove macros
822#
823%usertestrm /usr/lib/rpm/user_group.sh user testrm
824%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
825# user group membership management macros
826#
827# Usage:
828# %addusertogroup myuser agroup
829#
830%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 831
832# banner support (useful in {pre,post}{,un} and triggers)
833#
834# Usage:
aa41c920 835# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 836# the banner text, the banner text
aa41c920
ER
837# the banner text, and following line
838#EOF
839# You can use any form of here-document, <<'EOF' <<-EOT will do.
840# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
841#
72fcfcb3 842# -a - append to the banner
a8b9562a 843# -e - send to stderr instead of stdout
628754cb 844# -n - no show banner (overrides -t)
845# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
846#
847# Tests:
848# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
849# rpm -E 'date | %banner -e banner' > m; sh -x m
850#
afb54f6c 851%banner(aent:) ( \
1b334fe4 852RPM_SCRIPTVERBOSITY=5 \
853[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
854if [ -x /usr/bin/banner.sh ]; then \
aa41c920 855 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 856else \
a8b9562a 857 CMD="cat%{-e: >&2}" \
1b334fe4 858fi \
276a7b45
ER
859eval $CMD %{?2:%2}%{?3: %3}) \
860%{nil}
628754cb 861
990bd03f 862# useradd/groupadd macros
4c73bc69 863# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
864#
865# Usage:
866# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
867# [-g initial_group] [-G group[,...]] login
868#
869# -u uid. REQUIRED
870# -g gid/group. REQUIRED
871# -s defaults to /bin/false
872# -d defaults to /usr/share/empty
873# -c No default
874# -r is accepted but ignored (it's always set)
6bd4c218 875# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
876# rpm specific flags
877# -P package name. defaults to %{name}
878#
90627280 879%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
880%{!-u:%{error:useradd: Required argument -u missing}} \
881%{!-g:%{error:useradd: Required argument -g missing}} \
882%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
883if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
884 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
885 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
886 exit 1 \
887 fi \
888else \
889 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
890 /usr/sbin/useradd \\\
b5a7d552 891 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
892 -u %{-u*} \\\
893 -r \\\
894 -d %{-d*}%{!-d:/usr/share/empty} \\\
895 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 896 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
897 -g %{-g*} \\\
898 %{-M} \\\
899 %{-G:-G %{-G*}} \\\
1aac682a 900 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 901 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
902fi;
903
90627280
ER
904# Usage:
905# %groupadd [-P package] [-g gid] group
906#
907# -g gid. REQUIRED
908#
909# Sample:
910# %groupadd -P %{name}-base -g %{gid} %{name}
911
912%groupadd(g:P:rfo) \
9ba02ba9
ER
913%{!-g:%{error:groupadd: Required argument -g missing}} \
914%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 915if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
916 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
917 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
918 exit 1 \
919 fi \
920else \
921 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 922 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 923 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 924fi;
7cb77741 925
7c50f037 926# webapp macros
4c73bc69 927# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
928#
929# The config is installed/removed inside trigger, this means that you can any
930# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 931# updated. if you don't need the config for various reason for specific
35663282
ER
932# webserver, just remove the symlink from config directory using webapp
933# program. the trigger will not recreate the symlink on upgrades. In other
934# words the config is linked to webserver config directory on first install of
935# PACKAGE or WEBSERVER.
936#
7c50f037
ER
937# Add package's webserver config to webserver webapps dir.
938# Usage:
df979130 939# %webapp_register WEBSERVER WEBAPP
35663282
ER
940#
941%webapp_register() \
942%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
943if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
944 /usr/sbin/webapp register %1 %2\
945fi\
694a8f2e 946# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 947if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 948 %{expand:%service -q %%1 reload}\
35663282
ER
949fi\
950%{nil}
951
952# Remove package's config from webserver webapps dir.
35663282 953# Usage:
531c0efc
ER
954# %webapp_register [-f] WEBSERVER WEBAPP
955%webapp_unregister(f) \
35663282
ER
956%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
957# remove link if either of the packages are gone \
5d3a09a3 958if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 959 /usr/sbin/webapp unregister %1 %2\
16897aea 960 %{expand:%service -q %%1 reload}\
35663282
ER
961fi \
962%{nil}
963
462b26fa 964# service macro.
4c73bc69 965# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
966#
967# calls usual service restart on package %post, but skips the restart if
968# administrator has disabled automatic service restarts in either global
969# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
970#
462b26fa 971# Usage:
7377b5ca 972# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 973#
a0bbe604 974# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 975# -n NOOP mode, do not actually restart service
462b26fa 976#
7377b5ca
ER
977# Requirements:
978# BuildRequires: rpmbuild(macros) >= 1.268
979# Requires: rc-scripts
980# -n option:
981# BuildRequires: rpmbuild(macros) >= 1.450
982%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
983
984
f9aa75bf
ER
985# Java macros. based on jpackage macros.java
986#
987# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 988%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
989
990# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 991%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
992
993# Root directory for all Java VM/SDK/JRE's private things.
994%_jvmprivdir %{_libdir}/jvm-private
995
996# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 997%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
998
999# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1000%_jvmdatadir %{_datadir}/jvm
1001
1002# Root directory for all configurations parts of Java VM/SDK/JRE's
1003%_jvmsysconfdir %{_sysconfdir}/jvm
1004
1005# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1006%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1007
1008# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1009%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1010
1011# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1012%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1013
1014# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1015%_jnidir %{_libdir}/java
f9aa75bf 1016
c94807f3 1017%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1018
a9254650 1019%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1020%jar %{java_home}/bin/jar
c94807f3 1021%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1022%javac %{java_home}/bin/javac
1023%javadoc %{java_home}/bin/javadoc
6aedae62 1024
fe6c4bdd 1025%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1026
1027%jpackage_script() \
3ca65b87
ER
1028install -d $RPM_BUILD_ROOT%{_bindir}\
1029cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1030#!/bin/sh\
1031#\
1032# %{name} script\
1033# JPackage Project <http://www.jpackage.org/>\
1034\
1035# Source functions library\
1036. %{_javadir}-utils/java-functions\
1037\
1038# Source system prefs\
3ca65b87 1039if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1040 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1041fi\
1042\
1043# Source user prefs\
3ca65b87
ER
1044if [ -f $HOME/.%{name}rc ]; then\
1045 . $HOME/.%{name}rc\
6aedae62
ER
1046fi\
1047\
1048# Configuration\
1049MAIN_CLASS=%1\
1050BASE_FLAGS=%2\
1051BASE_OPTIONS=%3\
3ca65b87 1052BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1053\
1054# Set parameters\
1055set_jvm\
3ca65b87
ER
1056set_classpath $BASE_JARS\
1057set_flags $BASE_FLAGS\
1058set_options $BASE_OPTIONS\
6aedae62
ER
1059\
1060# Let's start\
3ca65b87 1061run "$@"\
6aedae62
ER
1062EOF
1063
06f11871
ER
1064# jpackage 1.7
1065# Directory for maven depmaps
1066#
1067%_mavendepmapdir /etc/maven
1068%_mavendepmapfragdir /etc/maven/fragments
1069
1070#
1071# add_to_depmap adds an entry to the depmap. The arguments are:
1072#
1073# %1 the original groupid
1074# %2 the original artifact id
1075# %3 the version
1076# %4 the new groupid
1077# %5 the new artifactid
1078#
1079
1080%add_to_maven_depmap() \
1081install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1082cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1083<dependency>\
1084 <maven>\
1085 <groupId>%1</groupId>\
1086 <artifactId>%2</artifactId>\
1087 <version>%3</version>\
1088 </maven>\
1089 <jpp>\
1090 <groupId>%4</groupId>\
1091 <artifactId>%5</artifactId>\
1092 <version>%3</version>\
1093 </jpp>\
1094</dependency>\
1095\
1096EOF\
1097%{nil}
1098
1099#==============================================================================
1100#
1101# update_maven_depmap updates the main maven depmap
1102#
1103%update_maven_depmap() \
1104echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1105if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1106cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1107fi\
1108echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1109
1110
59d3ebe9 1111# PEAR install macros
4c73bc69 1112# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1113#
1114# Usage:
f7ecf326 1115# %%pear_package_setup ...
dfce8b19 1116#
59d3ebe9 1117# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1118# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1119# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1120# -D - pass -D to %setup (so the build dir is not removed)
1121# -c - register channel from local channel.xml file
dfce8b19
ER
1122#
1123# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1124# destination hierarchy. you should copy the tree to buildroot after
1125# patching/reorganizing with %%pear_package_install.
1126#
1127# additionally BUILDROOT is stripped from files and files are converted to UNIX
1128# line endings.
1129#
1130# the pear install process output is recorded to install.log, you should put it
8763f51e 1131# to %%doc for later debug or just for information.
dfce8b19
ER
1132#
1133# additionally additional-packages.txt is produced if it was detected that the
1134# package has optional dependencies. the file format is suitable of displaying
1135# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1136# automatically added for this file.
59d3ebe9
ER
1137
1138
1139# records install.log and transforms PEAR names to PLD Linux rpm package names.
1140%__pear_install_log \
1141tee install.log \
1142# make post message of optional packages \
f64d1bb2 1143grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1144if [ -s optional-packages.txt ]; then \
1145 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1146else \
1147 rm -f optional-packages.txt \
1148fi \
1149%{nil}
1150
1151# command invoking pear cli
1152%__pear /usr/bin/pear
1153
67a089ff 1154%pear_install(a:n:zD) \
59d3ebe9 1155%__pear \\\
f7ecf326 1156 -c %{builddir}/pearrc \\\
dfce8b19 1157 -d doc_dir=/docs \\\
f7ecf326
ER
1158 -d temp_dir=/tmp \\\
1159 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1160 -d bin_dir=%{_bindir} \\\
1161 -d data_dir=%{php_pear_dir}/data \\\
1162 -d test_dir=%{php_pear_dir}/tests \\\
1163 install \\\
59d3ebe9 1164 --packagingroot=%{builddir} \\\
dfce8b19
ER
1165 --offline \\\
1166 --nodeps \\\
1167 %{-f:--force} \\\
67a089ff 1168 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1169 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1170%{nil}
1171
1172# The main macro.
1173# using this macro will append optional-packages.txt to the nocompressdoc list
1174# as it's displayed to user after package install. and adding additional gzip
1175# dep is just waste ;)
f7ecf326 1176%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1177%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1178%define builddir %{_builddir}/%{srcdir} \
1179%setup -q -c -T %{-D:-D} -n %{srcdir} \
1180%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1181%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1182%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1183%pear_install \
59d3ebe9
ER
1184%{-z:cd ..} \
1185cat %{-z:$_N/}.install.log | %__pear_install_log \
1186\
dfce8b19 1187# undos sources \
2a80e4cf 1188find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1189%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1190%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1191%{nil}
1192
7bef60e8 1193# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1194# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1195%pear_package_install() \
1196cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1197find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1198# help the developer out a little: \
1199if [ -f _noautoreq ]; then \
1200 echo "AutoReqdep detected:" \
1201 echo "_noautoreq $(cat _noautoreq)" \
1202fi \
1203%{nil}
1204
0d5dd00c
ER
1205
1206# Register OpenLDAP schema.
4c73bc69 1207# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1208#
1209# Usage:
1210# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1211#
1212# -d specify dependant schemas, separated by comma
1213#
1214%openldap_schema_register(d:) \
1215for schema in %*; do \
1216 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1217 %{__sed} -i -e " \
1218 /^include.*local.schema/{ \
1219 iinclude\\t $schema\
1220 } \
1221 " /etc/openldap/slapd.conf \
1222 fi \
1223done \
1224# enable dependant schemas \
1225if [ "%{-d*}" ]; then \
1226 %{__sed} -i -e ' \
1227 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1228 s/^#// \
1229 }' /etc/openldap/slapd.conf \
1230fi \
1231%{nil}
1232
1233# Unregister OpenLDAP schema.
4c73bc69 1234# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1235#
1236# Usage:
1237# %%openldap_schema_unregister %{schemadir}/horde.schema
1238#
1239%openldap_schema_unregister() \
1240for schema in %*; do \
1241 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1242 %{__sed} -i -e " \
1243 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1244 # for symmetry it would be nice if we disable enabled schemas in post, \
1245 # but we really can not do that, it would break something else. \
1246 " /etc/openldap/slapd.conf \
1247 fi \
1248done \
1249%{nil}
1250
b0bc2936 1251%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1252
dcc6baf7 1253
1254# Build modules for kernels 2.6
1255# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1256#
1257# Usage:
aa559e46 1258# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1259#
1260# remember that proper Makefile is still required
1261# Options:
990bd03f 1262# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1263# without .ko extension, may be placed in subdirectory
aa559e46 1264# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1265# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1266# -c -- do not execute make clean
dcc6baf7 1267# <additional arguments> -- all additional arguments will be passed to
1268# make modules
1269#
1270# Additional patching supported via here document. Try:
1271# %build_kernel_modules -m module <<'EOF'
1272# your patch script here
1273# EOF
1274# Don't use it unless patching depends on config options.
1275
1276# Developer note: don't touch it unless you know how to handle '\'.
1277# - \ in script expands to nothing
1278# - \\\ in script expands to \
566398b4 1279# - \\\ inside definition expands to nothing
dcc6baf7 1280# - \\\\\\\ inside definition expands to \
1281# - in last line \ has to touch arguments so arguments passing
1282# in new lines (using \) will be supported
1283
5a81d83e 1284%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1285%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1286 \
1287%define Opts \\\\\\\
1288%if "%{_target_base_arch}" != "%{_arch}" \\\
1289 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1290 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1291 %else \\\
1292 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1293 %endif \\\
1294%else \\\
88608ef7 1295 CC="%{kgcc}" \\\
dcc6baf7 1296%endif \
88608ef7 1297%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1298 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1299 \
e364bc26 1300%{?-C:cd %{-C*}} \
dcc6baf7 1301compile() { \
ba9de9b2
ER
1302 local L="<" PATCH_SH; \
1303 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1304 set -e -x \
730239f9 1305 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1306 \
730239f9 1307for cfg in ${cfgs:-dist}; do \
dcc6baf7 1308 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1309 \
c546f6fb 1310 rm -rf o \
dcc6baf7 1311 install -d o/include/linux \
1312 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1313 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1314 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1315 \
1316 set +x \
1317 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1318 set -x \
1319 \
c768535c 1320 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1321 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1322 %{-p*} %{-P*} \\\
1323 %{MakeOpts} \
1324 %else \
1325 install -d o/include/config \
1326 touch o/include/config/MARKER \
1327 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1328 %endif \
1329 \
5a81d83e 1330 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1331 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1332 ${1+"$@"} \\\
5a81d83e 1333 M=$PWD %{MakeOpts}} \
f635907b 1334 \
dcc6baf7 1335 %{__make} -C %{_kernelsrcdir} modules \\\
1336 ${1+"$@"} \\\
1337 M=$PWD %{MakeOpts} \
1338 \
1339 for MODULE in {%{-m*},}; do \
1340 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1341 done \
1342done \
aa559e46 1343%{?-C:cd -} \
dcc6baf7 1344} \
1345compile %{*}\
1346%{nil}
1347
1348
1349# Install kernel modules built by %build_kernel_modules
1350# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1351#
1352# Usage:
1353# %install_kernel_modules -m <modules> -d <directory>
1354#
1355# Options:
990bd03f 1356# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1357# without .ko extension, may be placed in subdirectory
1358# -d <directory> (required) -- in what subdirectory modules should be
1359# installed (eg. misc, kernel/drivers/net)
1360# -s <suffix> -- suffix to use when installing modules, useful when module
1361# with same name exists in kernel already
1362# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1363# for defining aliases, only useful with -s
dcc6baf7 1364
1365%install_kernel_modules(m:d:s:n:) \
1366%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1367%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1368%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1369 \
1370%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1371%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1372 \
730239f9 1373local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1374 \
1375for MODULE in {%{-m*},}; do \
1376 [ -n "${MODULE}" ] || continue \
730239f9
ER
1377 for cfg in ${cfgs:-dist}; do \
1378 [ "$cfg" = smp ] && suf=smp || suf= \
1379 MNAME=${MODULE##*/} \
1380 install -D ${MODULE}-$cfg.ko \\\
1381 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1382 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1383 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1384 >> %{ModprobeD}$suf/%{-n*}.conf} \
1385 done \
dcc6baf7 1386done \
1387%{nil}
1388
fa65356c 1389# patchset macros
4c73bc69 1390# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1391#
1392# Usage:
1393# %patchset_source -f <seq(1) format> <start> [<end>]
1394# %patchset_patch <start> [<end>]
1395#
1396# If <end> is omited, it is assumed to be <start>.
1397#
1398# For example in preamble:
1399# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1400# and in %prep:
1401# %patchset_patch 33 44
1402
1403# generate SourceX urls from range START STOP
1404# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1405# The sources start from 10000
e91610db 1406%patchset_source(f:b:) %(
44f733ef 1407 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1408 start=$(expr $base + %1);
1409 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1410 # we need to call seq twice as it doesn't allow two formats
1411 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1412 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1413 paste %{tmpdir}/__ps{1,2};
1414 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1415) \
1416%{nil}
fa65356c
ER
1417
1418# apply sources from %patchset_source
1419# -p specify -pX for %patch line
1420# -b base offset: defaults to 10000
1421%patchset_patch(f:p:b:) %(
44f733ef 1422 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1423 start=$(expr $base + %1);
1424 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1425 echo ": patchset_patch %1%{?2: to %2}";
1426 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1427) \
1428%{nil}
fa65356c 1429
5730b44b 1430# browser plugins v2
4c73bc69 1431# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1432#
1433# Usage:
1434# %browser_plugins_add_browser <name> -p <plugindir>
1435#
1436# <name> (required) -- name of the browser. usually %{name}.
1437# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1438# -b -- default blacklists
1439# -a <arch> override arch
5730b44b
ER
1440#
1441# Example:
1442# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1443
1444%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1445%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1446%update_browser_plugins /usr/sbin/update-browser-plugins || :
1447
02ebf70f 1448%browser_plugins_add_browser(p:b:a:) \
9efd458e 1449 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1450 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1451 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1452 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1453 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1454 %{-b:cat >> $blacklist_file %{-b*}} \
1455%{nil}
1456
ad17b654
ER
1457# Helper for LUA.
1458# split string separated by space into quoted list
1459#
4c73bc69 1460# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1461#
1462# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1463%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1464
1465# adjust /etc/shells by adding and removing shells from there
4c73bc69 1466# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1467#
1468# Usage:
d9b789d9
ER
1469# %post -p <lua>
1470# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1471#
d9b789d9
ER
1472# %preun -p <lua>
1473# if arg[2] == 0 then
1474# %lua_remove_etc_shells /bin/bash /bin/rbash
1475# end
7377b5ca
ER
1476#
1477# Requirements:
d9b789d9
ER
1478# BuildRequires: rpmbuild(macros) >= 1.462
1479#
ad17b654 1480
d9b789d9 1481%lua_add_etc_shells() \
ad17b654
ER
1482t = {}\
1483f = io.open("/etc/shells", "r")\
1484if f then\
1485 for l in f:lines() do t[l]=l; end\
1486 f:close()\
1487end\
1488for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1489 if not t[s] then\
b8c0bc18 1490 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1491 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1492 end\
1493end\
1494%{nil}
1495
d9b789d9
ER
1496%lua_remove_etc_shells() \
1497t = {}\
1498f = io.open("/etc/shells", "r")\
1499if f then\
1500 for l in f:lines() do t[l]=l; end\
1501 f:close()\
1502end\
1503for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1504 print("Removing "..l.." from /etc/shells")\
1505 t[l] = nil\
1506end\
1507s=""\
1508for _, l in pairs(t) do\
1509 s=s..l.."\\n"\
1510end\
1511io.open("/etc/shells", "w"):write(s)\
1512%{nil}
1513
1514# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1515#
1516# Author: Elan Ruusamäe <glen@pld-linux.org>
1517#
1518# Usage:
1519# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1520# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1521#
1522# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1523#
1524# Requirements:
1525# BuildRequires: rpmbuild(macros) >= 1.429
1526#
1527%add_etc_shells(p) %{-p:<lua>}\
1528%{expand:%%lua_add_etc_shells %*}\
1529%{nil}
1530
ad17b654 1531%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1532%{-p:if arg[2] == 0 then}\
d9b789d9 1533%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1534%{-p:end} \
ad17b654
ER
1535%{nil}
1536
75bd6249
ER
1537# Check syntax for Python files
1538#
1539# Author: Elan Ruusamäe <glen@pld-linux.org>
1540# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1541#
1542# Usage:
1543# %py_lint src
1544#
1545# Requirements:
1546# BuildRequires: python
1547# BuildRequires: rpmbuild(macros) >= 1.469
1548
1549%py_lint() \
1550__py_lint() { \
1551find "$@" -type f -name '*.py' | python -c ' \
1552import sys \
1553import compiler \
1554\
1555err = 0\
1556for f in sys.stdin: \
1557 fd = open(f.strip()) \
1558 c = fd.read() \
1559 fd.close() \
1560 try: \
1561 compiler.parse(c) \
1562 except SyntaxError, e: \
1563 print "py_lint: %s: %s" % (f.strip(), e) \
1564 err = err + 1\
1565\
1566if err: \
1567 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1568 sys.exit(1) \
1569else: \
1570 print >> sys.stderr, "py_lint: Found no syntax errors." \
1571' \
1572}; __py_lint %* \
1573%{nil}
1574
59d3ebe9 1575# vim:ts=4 sw=4 noet syn=spec
This page took 0.540458 seconds and 4 git commands to generate.